# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers. Who are looking to Innovate with Ingram Micro's API SolutionsAutomate your eCommerce with our offering of APIs and Webhooks to create a seamless experience for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class OrderCreateRequestLinesInnerEndUserInfoInner(BaseModel):
    """
    OrderCreateRequestLinesInnerEndUserInfoInner
    """ # noqa: E501
    end_user_type: Optional[StrictStr] = Field(default=None, description="Specifies the type of endUser. It can be endUser or endUserContact for SAP flow.", alias="endUserType")
    end_user_id: Optional[Annotated[str, Field(strict=True, max_length=10)]] = Field(default=None, description="ID for the end user/customer in Ingram Micro's system.", alias="endUserId")
    contact: Optional[StrictStr] = Field(default=None, description="The contact name for the end user/customer.")
    company_name: Optional[StrictStr] = Field(default=None, description="The company name for the end user/customer.", alias="companyName")
    name1: Optional[Annotated[str, Field(strict=True, max_length=35)]] = Field(default=None, description="name1")
    name2: Optional[StrictStr] = Field(default=None, description="name2")
    address_line1: Optional[StrictStr] = Field(default=None, description="The end user/customer's street address and building or house number.", alias="addressLine1")
    address_line2: Optional[StrictStr] = Field(default=None, description="The end user/customer's apartment number.", alias="addressLine2")
    address_line3: Optional[StrictStr] = Field(default=None, description="Line 3 of the address for the end user/customer.", alias="addressLine3")
    address_line4: Optional[StrictStr] = Field(default=None, description="Street address4", alias="addressLine4")
    city: Optional[StrictStr] = Field(default=None, description="The end user/customer's city.")
    state: Optional[StrictStr] = Field(default=None, description="The end user/customer's state.")
    postal_code: Optional[StrictStr] = Field(default=None, description="The end user/customer's zip or postal code.", alias="postalCode")
    country_code: Optional[Annotated[str, Field(strict=True, max_length=3)]] = Field(default=None, description="The end user/customer's two-character ISO country code.", alias="countryCode")
    phone_number: Optional[Union[Annotated[float, Field(strict=True)], Annotated[int, Field(strict=True)]]] = Field(default=None, description="The end user/customer's phone number.", alias="phoneNumber")
    email: Optional[Annotated[str, Field(strict=True, max_length=241)]] = Field(default=None, description="The end user/customer's email.")
    __properties: ClassVar[List[str]] = ["endUserType", "endUserId", "contact", "companyName", "name1", "name2", "addressLine1", "addressLine2", "addressLine3", "addressLine4", "city", "state", "postalCode", "countryCode", "phoneNumber", "email"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderCreateRequestLinesInnerEndUserInfoInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderCreateRequestLinesInnerEndUserInfoInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endUserType": obj.get("endUserType"),
            "endUserId": obj.get("endUserId"),
            "contact": obj.get("contact"),
            "companyName": obj.get("companyName"),
            "name1": obj.get("name1"),
            "name2": obj.get("name2"),
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "addressLine3": obj.get("addressLine3"),
            "addressLine4": obj.get("addressLine4"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "postalCode": obj.get("postalCode"),
            "countryCode": obj.get("countryCode"),
            "phoneNumber": obj.get("phoneNumber"),
            "email": obj.get("email")
        })
        return _obj


